//==============================================================================
//Ŀ		:XC8M9003-DEMO
//MCU		  :XC8M9003
//		:Tina
//ʱ		:8M 4Clock 
//	  :2022.01.19
//============================================================================== 
#include "XC8M9003.h"
#include "XJ_9003Define.h"
volatile __at(0x10) unsigned char IntVecIdx;	
//===================================//
//===================================//
/*void file_clrRam();
void file_init();
void file_project_init();*/

void TC0_Init();			//TC0жϳʼ
void TC1_Init();			//TC1жϳʼ
void INT0INT1_Init();		//ⲿж
void IC_Init();				//ڱ仯ж

void file_scanKey();		//
void file_keyDeal();		//
void file_modeDeal();		//ģʽִ
void file_sleep();			//˯ӳ

void file_rtcSet();			//RTCӳ
void file_pwm_set();		//pwmӳ

void file_lvdSet();
void file_lvdTest();		//LVD
void file_lvdDeal();		//LVDִ

void file_adcSet();			//AD
void file_adc_start();		//AD
void file_adc_deal();		//AD
void file_dangWei_deal();	//
//========================================//
//===========ӳ===================//
//========================================//
void EEPROM_WRITE_BYTE(unsigned char ADDR,unsigned char DAT);
void EEPROM_READ_BYTE(unsigned char ADDR);
//===================================//
//ʼRAM:10H~3FH
//===================================//
void file_clrRam()
{
	for(RSR=0x00;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	{IAR = 0;}
	 IAR = 0;
}
//===================================//
//˿ڳʼ
//===================================//
void file_init(void)
{	
	PORT5 = 0x00;		//P5
	PORT6 = 0x00;		//P6
	PORT7 = 0x00;		//P7
	P5CR  = 0x00;		//P5Ϊ
	P6CR  = 0x08;		//P63ӰP6Ϊ
	P7CR  = 0x00;		//P7Ϊ
   P6PHCR = 0xf7;		//P63

/*	P5CR  = 0x40;	//P56Ϊ
	P7CR  = 0x02;	//P71Ϊ
	P5PHCR  = 0xBF;	//P56
	P7PHCR  = 0xFD;	//P71*/
}
//=========================================//
//TC0ʼ
//=========================================//
void file_project_init(void)
{
//-----------------------------------------
//TC0/TC1ж 
//-----------------------------------------
	TC0_Init();		//TC0жϳʼ
	TC1_Init();		//TC1жϳʼ
//-----------------------------------------
//RTC
//-----------------------------------------	 
//	file_rtcSet();  //RTCʱTC0)
//-----------------------------------------
//INT0/INT1ж 
//-----------------------------------------
//	INT0INT1_Init();
//-----------------------------------------
//˿ڱ仯ж 
//-----------------------------------------
//	IC_Init(); 
//-----------------------------------------
//ѹ
//-----------------------------------------
//	file_lvdSet();
//-----------------------------------------
//		PWM0
//----------------------------------------- 
//	file_pwm_set();
//-----------------------------------------
//		ADC
//----------------------------------------- 
//	file_adcSet();
//------дEEPROM-------------
//reg_keyMode=3;
//EEPROM_WRITE_BYTE(0x30,reg_keyMode);	//״̬־λдEEPROMַ0x30	
//---------------------------			
//-----------------------------------------
//EEPROM
//----------------------------------------- 
	EEPROM_READ_BYTE(0x30);				//ȡEEPROMַ0
	reg_keyMode=E2PDAT_READ;
	if(reg_keyMode>=4)
	{
		reg_keyMode=0;
	}/**/
}
//===================================// 
//жϷ  ADжADC
//===================================//
void int_isr(void) __interrupt
{   __asm__("org 0x03");__asm__("mov a,PCL");__asm__("jmp 0x33");		//TC0ж
	__asm__("org 0x06");__asm__("mov a,PCL");__asm__("jmp 0x33");		//PORTж
	__asm__("org 0x09");__asm__("mov a,PCL");__asm__("jmp 0x33");		//INT0ж
	__asm__("org 0x0c");__asm__("mov a,PCL");__asm__("jmp 0x33");		//INT1ж
	__asm__("org 0x0f");__asm__("mov a,PCL");__asm__("jmp 0x33");		//ADCж
	__asm__("org 0x12");__asm__("mov a,PCL");__asm__("jmp 0x33");		//CMP0ж
	__asm__("org 0x15");__asm__("mov a,PCL");__asm__("jmp 0x33");		//CMP1ж
	__asm__("org 0x18");__asm__("mov a,PCL");__asm__("jmp 0x33");		//TC1ж
	__asm__("org 0x1b");__asm__("mov a,PCL");__asm__("jmp 0x33");		//PRD0ж
	__asm__("org 0x1e");__asm__("mov a,PCL");__asm__("jmp 0x33");		//PRD1ж
	__asm__("org 0x21");__asm__("mov a,PCL");__asm__("jmp 0x33");		//PRD2ж
	__asm__("org 0x24");__asm__("mov a,PCL");__asm__("jmp 0x33");		//PRD3ж
	__asm__("org 0x27");__asm__("mov a,PCL");__asm__("jmp 0x33");		//DT0ж
	__asm__("org 0x2a");__asm__("mov a,PCL");__asm__("jmp 0x33");		//DT1ж
	__asm__("org 0x2d");__asm__("mov a,PCL");__asm__("jmp 0x33");		//DT2ж
	__asm__("org 0x30");__asm__("mov a,PCL");__asm__("jmp 0x33");		//DT3ж
	__asm__("org 0x33");__asm__("mov _IntVecIdx,a");
	
	switch(IntVecIdx)
	{
		case 0x04:	//TC0ж
		{
			ISR1 &= 0xfe;		//TC0жϱ־λ
			TC0C += 0x06;		//ֵ
			//PORT6 ^= 0x80;		//P67ȡ
			bit_end1ms=1;
			break;
		}
		case 0x07:	//PORTж
		{
			ISR1 &= 0xfd;		//˿ڱ仯жϱ־λ
		   PORT5 ^= 0x08;		//P53ȡ 
			break;
		}/**/
		case 0x0A:	//INT0ж
		{
			ISR1 &= 0xfb;		//INT0жϱ־λ
		   PORT5 ^= 0x08;		//P53ȡ 
			break;
		}
		case 0x0D:	//INT1ж
		{
			ISR1 &= 0xf7;		//INT1жϱ־λ
		   PORT5 ^= 0x10;		//P54ȡ 
			break;	
		}/**/
		//case 0x10:	//ADCж
		//case 0x13:	//CMP0ж
		//case 0x16:	//CMP1ж
		case 0x19:	//TC1ж
		{
			ISR1 &= 0x7f;	//TC1жϱ־λ
		//	PORT6 ^= 0x40;	//P66ȡ
			break;
		}
		case 0x1C:	//PRD0ж
		{
			ISR2 &= 0xfe;	//PWM0IFжϱ־λ 
//			PORT5 ^= 0x04;	//P52ȡ
			break;
		}
		case 0x1F:	//PRD1ж
		{		
			ISR2 &= 0xfd;	//PWM1IFжϱ־λ 
	//	PORT5 ^= 0x01;		//P50ȡ
			PORT5 ^= 0x04;	//P52//ȡ
			break;
		}
		case 0x22:	//PRD2ж
		{		
			ISR2 &= 0xfb;	//PWM2IFжϱ־λ 
	 	PORT5 ^= 0x04;	//P52//ȡ
			break;
		}
		case 0x25:	//PRD3ж
		{		
			ISR2 &= 0xf7;	//PWM3IFжϱ־λ  
	 	PORT5 ^= 0x04;	//P52//ȡ
			break;
		}
		case 0x28:	//DT0ж
		{
			if(ISR2_4==1)
			{
				ISR2 &= 0xef;		//DT0IFжϱ־λ
		//		PORT5 ^= 0x01;		//P50ȡ 
		//		PORT5 ^= 0x02;		//P51ȡ
			}
			break;
		}
		case 0x2B:	//DT1ж
		{
			ISR2 &= 0xdf;		//DT1IFжϱ־λ 
		//PORT5 ^= 0x01;		//P50ȡ
			PORT5 ^= 0x02;		//P51ȡ
			break;
		}
		case 0x2E:	//DT2ж
		{
			ISR2 &= 0xbf;		//DT2IFжϱ־λ 
			PORT5 ^= 0x02;		//P51ȡ
			break;
		}
		case 0x31:	//DT3ж	
		{
			ISR2 &= 0x7f;		//DT3IFжϱ־λ
			PORT5 ^= 0x02;		//P51ȡ
			break;
		}/**/			
	}	
}
//===================================//
//MAIN
//===================================//
void main()
{
	file_clrRam();					//RAM
	file_init();					//ioĴʼ
	file_project_init();			//蹦
	EI();							//ж
	while(1)
	{
		if(bit_end1ms)
		{
			bit_end1ms=0;
			NOP();
			NOP();
			NOP();
//-----------EEPROM---------------------------------
			file_scanKey();		////
			file_keyDeal();	//	//
			file_modeDeal();//	//ģʽִ
//-----------sleep---------------------------------
//		file_sleep();//		//ڱ仯//
//-----------LVD---------------------------------
//			file_lvdTest();		//LVD
//			file_lvdDeal();		//LVDִ
//-----------AD⼰ִ---------------------------------
//			file_adc_start();	
//			file_adc_deal();
//			file_dangWei_deal();
		}
	}
}
 	